/*
 * $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred."
 *
 */
/*	Copyright (c) 1984 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident  "@(#)$Header: fpsetsticky.c 1.3 89/10/10 $"

#include <ieeefp.h>
#include "fp.h"

#if !i387
fp_except
fpsetsticky(newsticky)
fp_except newsticky;
{
	struct _pcr1167 pcr;
	fp_except oldsticky;

	_getpcr(&pcr);
	oldsticky = (fp_except)pcr.excp;
	pcr.excp = newsticky;
	_putpcr(pcr);
	return oldsticky;
}
#else
fp_except
fpsetsticky(newsticky)
fp_except newsticky;
{
	struct _sw87 sw;
	_envbuf87 buf;
	fp_except oldsticky;

	_getsw(sw);
	oldsticky = (fp_except)sw.excp;
	sw.excp = newsticky;
	_putsw(sw, buf);
	return oldsticky;
}
#endif
